
(new)

(set-message-level 1)
;;---------------------- B. PLAQUE -------------------------------
;; B.1. Paramtres physiques plaque 


(setq my-plate
      (set-pitch 
       (make-object 'clamped-circ-plate 
; (modes 300)
                    (modes 30)
                    (thickness .01)
                    (freq-loss .01) 
                    (const-loss .08) 
                    (young 3.1e5)
                    (poisson .27)
                   (density 3200))
'radius 100)
   ;    'radius (/ 1 100))
)


;;---------------------- B. PLAQUE -------------------------------




;;---------------------- A. MARTEAU ------------------------------

;; A.1. Paramtres physiques du marteau
;; const. controlers 9  16

(defvar my-point)
(setq my-point (make-object 'single-point

  ;   (freqs '(.2 .4 .6 .8 .10))
 (freqs '(222 444 666 888 1110))
         (bws '(8. 4. 2. 1. 0.5))

         (amps '(1. 0.866 0.707 0.612 0.5)) ))



(defvar my-point1)
(setq my-point1 (make-object 'single-point

      (freqs '(220 440 660 880 1100))

         (bws '(8. 4. 2. 1. 0.5))

         (amps '(1. 0.866 0.707 0.612 0.5)) ))


;; B.2. Accs Input Plaque

;; make plate input
(defvar my-plate-hit)
(setq my-plate-hit (make-access my-plate (const .1 0) 'normal)) ;  Distance par rapport au centre uniquement dans la doc. Doit tre spcifi mais ignor. 

(defvar my-plate1-hit)
(setq my-plate1-hit (make-access my-plate (const .1 0) 'normal)) ;  Distance par rapport au centre uniquement dans la doc. Doit tre spcifi mais ignor. 


;(setq my-plate-hit  (make-access my-plate

 ;             (make-controller 'envelope 2
  ;                             (list   	(list  0.   0.9999   )
 ;                                       (list  30.   0.00001   ))
 ;             ) 
 ;             'normal))


;; dynamique ou statique?



;; A.2. Sortie Marteau
;; => Output 'Felt Connection

(defvar my-point-hit);; make hammer output
(setq my-point-hit (make-access my-point (const 0) 'normal))

(defvar my-point-mov)
(setq my-point-mov (make-access my-point (const 1) 'normal))



(defvar my-point1-hit);; make hammer output
(setq my-point1-hit (make-access my-point1 (const 0) 'normal))

(defvar my-point1-mov)
(setq my-point1-mov (make-access my-point1 (const 1) 'normal))



;; C. FELT Connection (static params, controled externally in Max)



(make-connection 'felt my-plate-hit .0  my-point-hit .1  (const .00001) (const 1e+9) (const 2.5) (const 0.83) (const 0.0035) (const 1)) 

; try with different initial positions for the point

(make-connection 'felt my-plate1-hit .0  my-point1-hit .9  (const .00001) (const 1e+9) (const 2.5) (const 0.83) (const 0.0035) (const 1))



;;---------------------- A. MARTEAU ------------------------------
;; A.2. Entre Sortie Marteau

;;; make position connection to push hammer




(defvar my-point-mov)
(setq my-point-mov (make-access my-point (const 0) 'normal)) ;;mlys: dynamic controler 8 hammer @access-in-1-position a priori pas dynamique
;; contrle du niveau d'entre sonore
(make-connection 'position my-point-mov
         
                                 (make-controller 'envelope 1
                                           (list (list 0.0   .1)
                                        (list .02   -.8)
                                  )))



(defvar my-point1-mov)
(setq my-point1-mov (make-access my-point1 (const 0) 'normal)) ;;mlys: dynamic controler 8 hammer @access-in-1-position a priori pas dynamique
;; contrle du niveau d'entre sonore

(make-connection 'position my-point1-mov
         
                                 (make-controller 'envelope 1
                                           (list (list 0.   1.)
(list 5.50   .1)
(list 5.515   -.8)
                                      
                                  )))



;;  dynamic controler 9, hammer @access-out-1-position


;;make listening point


(defvar my-plate-out)
(setq my-plate-out (make-access my-plate (const .9 0) 'normal))

(defvar my-plate1-out)
(setq my-plate1-out (make-access my-plate (const .9 90) 'normal))



(make-point-output my-plate-out)

(make-point-output my-plate1-out)


;(defvar graph)
;(setq graph (make-plot))
;(plot-value graph "hammer mov"  (make-controller 'access-position 1 my-hammer-mov))
;(plot-value graph "hammer tip"  (make-controller 'access-position 1 my-hammer-hit))

;(plot-value graph "plate tip"  (make-controller 'access-position 1 my-plate-hit))


;;;
;;; arrange the plot, run the synthesis and play the sound
;;;

(run 20)

;(plot graph "hammered plate (example 2)" 0 0. .1 -.1 .1)
(play)